diff --git a/drivers/i2c/ast2600_i2c.c b/drivers/i2c/ast2600_i2c.c
index f1aebe0b733f..5eda2909c661 100644
--- a/drivers/i2c/ast2600_i2c.c
+++ b/drivers/i2c/ast2600_i2c.c
@@ -385,7 +385,7 @@ static const struct dm_i2c_ops ast2600_i2c_ops = {
 };
 
 static const struct udevice_id ast2600_i2c_ids[] = {
-	{ .compatible = "aspeed,ast2600-i2c" },
+	{ .compatible = "aspeed,ast2600-i2c-bus" },
 	{},
 };
 
diff --git a/arch/arm/dts/ast2600.dtsi b/arch/arm/dts/ast2600.dtsi
index 7b39bbbd20b7..72f21c834bf0 100644
--- a/arch/arm/dts/ast2600.dtsi
+++ b/arch/arm/dts/ast2600.dtsi
@@ -796,7 +796,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x80 0x80 0xC00 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 110 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -811,7 +811,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x100 0x80 0xC20 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 111 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -826,7 +826,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x180 0x80 0xC40 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 112 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -840,7 +840,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x200 0x40 0xC60 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 113 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -854,7 +854,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x280 0x80 0xC80 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 114 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -868,7 +868,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x300 0x40 0xCA0 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 115 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -882,7 +882,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x380 0x80 0xCC0 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 116 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -896,7 +896,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x400 0x80 0xCE0 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 117 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -910,7 +910,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x480 0x80 0xD00 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 118 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -924,7 +924,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x500 0x80 0xD20 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 119 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -939,7 +939,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x580 0x80 0xD40 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 120 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -954,7 +954,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x600 0x80 0xD60 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 121 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -969,7 +969,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x680 0x80 0xD80 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 122 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -984,7 +984,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x700 0x80 0xDA0 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 123 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -999,7 +999,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x780 0x80 0xDC0 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 124 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;
@@ -1014,7 +1014,7 @@
 		#interrupt-cells = <1>;
 
 		reg = <0x800 0x80 0xDE0 0x20>;
-		compatible = "aspeed,ast2600-i2c";
+		compatible = "aspeed,ast2600-i2c-bus";
 		bus-frequency = <100000>;
 		interrupts = <GIC_SPI 125 IRQ_TYPE_LEVEL_HIGH>;
 		clocks = <&scu ASPEED_CLK_APB2>;